'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _reactFlex = require('react-flex');

var _join = require('../../join');

var _join2 = _interopRequireDefault(_join);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _getColumnsInfo2 = require('../../utils/getColumnsInfo');

var _getColumnsInfo3 = _interopRequireDefault(_getColumnsInfo2);

var _InnerWrapper = require('./InnerWrapper');

var _InnerWrapper2 = _interopRequireDefault(_InnerWrapper);

var _Header = require('./Header');

var _Header2 = _interopRequireDefault(_Header);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ColumnGroup = function (_Component) {
  _inherits(ColumnGroup, _Component);

  function ColumnGroup(props) {
    _classCallCheck(this, ColumnGroup);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ColumnGroup).call(this, props));

    _this.refHeader = function (h) {
      _this.header = h;
    };
    return _this;
  }

  _createClass(ColumnGroup, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      if (nextProps.shouldComponentUpdate) {
        return nextProps.shouldComponentUpdate(nextProps, this.props);
      }

      return !(0, _shallowequal2.default)(nextProps, this.props);
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var viewportHeight = props.viewportHeight;
      var width = props.width;
      var fixed = props.fixed;
      var innerWrapperOffset = props.innerWrapperOffset;
      var header = props.header;
      var columns = props.columns;
      var isMultiSort = props.isMultiSort;
      var sortable = props.sortable;
      var sortInfo = props.sortInfo;
      var resizable = props.resizable;
      var columnMinWidth = props.columnMinWidth;
      var data = props.data;


      var flex = props.flex;

      var style = (0, _objectAssign2.default)({}, props.style, {
        // height: viewportHeight,
      });

      if (width !== undefined) {
        style.width = width;
      }

      var _getColumnsInfo = (0, _getColumnsInfo3.default)(columns);

      var minWidth = _getColumnsInfo.minWidth;
      var maxWidth = _getColumnsInfo.maxWidth;

      // Fixed means that it is not allowed to have horizontal scroll

      if (fixed) {
        style.minWidth = minWidth;
        flex = false;
      }

      var className = (0, _join2.default)('react-datagrid__column-group', props.className);

      var innerWrapperStyle = {
        transform: 'translate3d(0,' + innerWrapperOffset + 'px, 0)'
      };

      return _react2.default.createElement(
        _reactFlex.Item,
        _extends({}, props, {
          flex: flex,
          className: className,
          style: style,
          data: null,
          onScroll: this.onScroll
        }),
        header && _react2.default.createElement(_Header2.default, {
          ref: this.refHeader,
          data: data,
          columns: columns,
          minWidth: minWidth,
          maxWidth: maxWidth,
          onCellClick: props.onHeaderCellClick,
          onSortClick: props.onHeaderSortClick,
          isMultiSort: isMultiSort,
          sortable: sortable,
          sortInfo: sortInfo,
          resizable: resizable,
          onResize: this.onResize,
          onResizeMouseDown: this.onResizeMouseDown
        }),
        _react2.default.createElement(
          'div',
          { className: 'react-datagrid__column-group__body' },
          _react2.default.createElement(
            'div',
            {
              className: 'react-datagrid__column-group__body__inner-wrapper',
              style: innerWrapperStyle
            },
            _react2.default.createElement(_InnerWrapper2.default, _extends({}, props, {
              columns: columns,
              minWidth: minWidth,
              maxWidth: maxWidth,
              innerWrapperOffset: null
            }))
          )
        )
      );
    }
  }, {
    key: 'onResizeMouseDown',
    value: function onResizeMouseDown(headerProps, colHeaderNode, event) {
      if (this.props.onResizeMouseDown) {
        this.props.onResizeMouseDown({
          absoluteIndex: headerProps.absoluteIndex,
          colHeaderNode: colHeaderNode,
          headerNode: (0, _reactDom.findDOMNode)(this.header),
          event: event
        });
      }
    }
  }, {
    key: 'onResize',
    value: function onResize(_ref) {
      var height = _ref.height;

      if (this.props.onHeaderHeightChange) {
        this.props.onHeaderHeightChange(height);
      }
    }
  }, {
    key: 'onScroll',
    value: function onScroll(ev) {
      ev.stopPropagation();
      this.props.onScroll(ev);
    }
  }]);

  return ColumnGroup;
}(_reactClass2.default);

exports.default = ColumnGroup;


ColumnGroup.defaultProps = {
  isColumnGroup: true,
  flex: 1
};

ColumnGroup.propTypes = {
  children: function children(props, propName) {
    var children = props[propName];

    _react2.default.Children.map(children, function (child) {
      if (!child || !child.props || !child.props.isColumn) {
        return new Error('The only children allowed of Datagrid are ColumnGroup');
      }
    });
  },
  onRowMouseEnter: _react.PropTypes.func,
  onRowMouseLeave: _react.PropTypes.func
};