'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _reactFlex = require('react-flex');

var _dragHelper = require('drag-helper');

var _dragHelper2 = _interopRequireDefault(_dragHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IS_MAC = global && global.navigator && global.navigator.appVersion && global.navigator.appVersion.indexOf('Mac') != -1;

var IS_FIREFOX = global && global.navigator && global.navigator.userAgent && !! ~global.navigator.userAgent.toLowerCase().indexOf('firefox');

var Scroller = function (_Component) {
  _inherits(Scroller, _Component);

  function Scroller() {
    _classCallCheck(this, Scroller);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Scroller).apply(this, arguments));
  }

  _createClass(Scroller, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.scrollAt(this.props.scrollTop);
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;

      var itemHeight = props.itemHeight;
      var dataLength = props.dataLength;
      var contentHeight = props.contentHeight;
      var scrollTop = props.scrollTop;
      var height = props.height;
      var scrollbarWidth = props.scrollbarWidth;
      var hasScroll = props.hasScroll;


      var scrollContentStyle = {
        height: contentHeight
      };

      var contentStyle = {
        // maxHeight: height,
        // minHeight: height, // needed for ie
      };

      if (hasScroll) {
        contentStyle.maxWidth = 'calc(100% - ' + scrollbarWidth + 'px)';
      }

      var scrollerStyle = {
        height: height,
        maxHeight: height,
        maxWidth: scrollbarWidth,
        minWidth: scrollbarWidth,
        position: 'relative',
        top: this.props.headerHeight
      };

      return _react2.default.createElement(
        _reactFlex.Flex,
        {
          row: true,
          wrap: false,
          alignItems: 'stretch',
          className: 'react-datagrid__scroller'
        },
        _react2.default.createElement(
          _reactFlex.Flex,
          {
            flex: 1,
            className: 'react-datagrid__scroller__content',
            alignItems: 'stretch',
            wrap: false,
            ref: 'viewport',
            onWheel: this.onWheel,
            onTouchStart: this.onTouchStart,
            style: contentStyle
          },
          props.children
        ),
        hasScroll && _react2.default.createElement(
          'div',
          {
            ref: 'scrollbar',
            className: 'react-datagrid__scroller__scrollbar',
            onScroll: this.onScrollBarScroll,
            style: scrollerStyle
          },
          _react2.default.createElement('div', {
            className: 'react-datagrid__scroller__scrollbar__content',
            ref: 'scrollBarContent',
            style: scrollContentStyle
          })
        )
      );
    }

    // onScroll is triggered indirectly by:
    // - onWheel
    // - onTouch
    // - onScroll by scrollbar

  }, {
    key: 'onScroll',
    value: function onScroll(scrollTop, event) {
      if (!this.props.hasScroll) {
        return;
      }

      var newScrollTop = this.normalizeScrollTop(scrollTop);

      if (newScrollTop != this.props.scrollTop) {
        this.props.onScroll(newScrollTop, event);
        // this.onScrollDebounced(scrollTop, event)
      }
    }
  }, {
    key: 'onScrollBarScroll',
    value: function onScrollBarScroll(event) {
      if (event.target.scrollTop !== this.props.scrollTop) {
        this.onScroll(event.target.scrollTop, event);
      }
    }
  }, {
    key: 'onWheel',
    value: function onWheel(event) {
      var props = this.props;
      var scrollStep = props.scrollStep;
      var scrollTop = props.scrollTop;
      var maxScrollTop = props.maxScrollTop;
      var deltaY = event.deltaY;
      var deltaX = event.deltaX;


      var newScrollTop = scrollTop;

      if (deltaY < 0) {
        newScrollTop += deltaY * scrollStep;
      } else {
        newScrollTop += deltaY * scrollStep;
      }

      if (Math.abs(deltaX) < Math.abs(deltaY)
      // don't prevent default when thre is no scroll, or scrollTop === 0 or maxScrollTop
       && this.props.hasScroll && newScrollTop < maxScrollTop && newScrollTop > 0) {
        event.preventDefault();
      }

      this.onScroll(newScrollTop, event);
    }
  }, {
    key: 'onTouchStart',
    value: function onTouchStart(event) {
      var _this2 = this;

      (0, _dragHelper2.default)(event.nativeEvent, {
        scope: this,
        onDragStart: function onDragStart(event, config) {
          _this2.initialScrollStart = _this2.props.scrollTop;
        },
        onDrag: function onDrag(event, config) {

          if (Math.abs(config.diff.left) <= Math.abs(config.diff.top * 4)) {
            event.stopPropagation();
            event.preventDefault();
          }

          var newScrollPos = _this2.initialScrollStart - config.diff.top;

          _this2.onScroll(newScrollPos, event);
        },

        onDrop: function onDrop(event, config) {
          _this2.initialScrollStart = null;
        }
      });
    }
  }, {
    key: 'scrollAt',
    value: function scrollAt(scrollTop) {
      if (this.props.hasScroll) {
        this.refs.scrollbar.scrollTop = this.normalizeScrollTop(scrollTop);
      }
    }
  }, {
    key: 'normalizeScrollTop',
    value: function normalizeScrollTop(scrollTop) {
      var maxScrollTop = this.props.maxScrollTop;

      var newScrollTop = ~ ~scrollTop;

      if (newScrollTop < 0) {
        newScrollTop = 0;
      }

      if (newScrollTop > maxScrollTop) {
        newScrollTop = maxScrollTop;
      }

      return newScrollTop;
    }
  }]);

  return Scroller;
}(_reactClass2.default);

Scroller.defaultProps = {
  scrollStep: IS_FIREFOX ? 40 : 1
};

Scroller.propTypes = {
  className: _react.PropTypes.string,
  scrollTop: _react.PropTypes.number,
  scrollStep: _react.PropTypes.number
};

exports.default = Scroller;