'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref, _ref2, event) {
  var region = _ref.region;
  var headerRegion = _ref.headerRegion;
  var constrainTo = _ref.constrainTo;
  var columnHeaderNodes = _ref.columnHeaderNodes;
  var columns = _ref.columns;
  var index = _ref.index;
  var initialSize = _ref.initialSize;
  var extraOffset = _ref.extraOffset;
  var _ref2$onResizeDragIni = _ref2.onResizeDragInit;
  var onResizeDragInit = _ref2$onResizeDragIni === undefined ? emptyFn : _ref2$onResizeDragIni;
  var _ref2$onResizeDragSta = _ref2.onResizeDragStart;
  var onResizeDragStart = _ref2$onResizeDragSta === undefined ? emptyFn : _ref2$onResizeDragSta;
  var _ref2$onResizeDrag = _ref2.onResizeDrag;
  var onResizeDrag = _ref2$onResizeDrag === undefined ? emptyFn : _ref2$onResizeDrag;
  var _ref2$onResizeDrop = _ref2.onResizeDrop;
  var onResizeDrop = _ref2$onResizeDrop === undefined ? emptyFn : _ref2$onResizeDrop;

  event.preventDefault();

  var column = columns[index];

  var initialLeft = region.left - headerRegion.left;

  var isContrained = function isContrained(config) {
    var constrained = config.dragRegion.left == constrainTo.left || config.dragRegion.right == constrainTo.right;

    return constrained;
  };

  (0, _dragHelper2.default)(event, {
    constrainTo: constrainTo,
    region: region,
    onDragInit: onResizeDragInit.bind(this, {
      offset: initialLeft,
      initialLeft: initialLeft
    }),
    onDragStart: function onDragStart(e, config) {
      var constrained = isContrained(config);

      onResizeDragStart({
        initialLeft: initialLeft,
        offset: initialLeft,
        constrained: constrained,
        resizing: true,
        column: column
      });
    },
    onDrag: function onDrag(e, config) {
      var diff = config.diff.left;
      var offset = initialLeft + diff;

      var constrained = isContrained(config);

      onResizeDrag({
        constrained: constrained,
        initialLeft: initialLeft,
        diff: diff,
        offset: offset,
        column: column
      });
    },
    onDrop: function onDrop(e, config) {
      var diff = config.diff.left;
      var offset = initialLeft + diff;

      var constrained = isContrained(config);

      var size = initialSize + diff - region.width / 2; // exclude the width of the drag handle

      onResizeDrop({
        index: index,
        constrained: constrained,
        initialLeft: initialLeft,
        diff: diff,
        offset: offset,
        size: size,
        column: column
      });
      return;
      var nextColumn = diff > 0 ? null : columns[index + 1];

      var columnSize = _region2.default.from(columnHeaderNodes[index]).width;
      var nextColumnSize = void 0;
      var firstSize = columnSize + diff;
      var secondSize = 0;

      // if (firstSize < column.minWidth){
      //     firstSize = column.minWidth
      //     diff = firstSize - columnSize
      // }

      if (nextColumn) {
        nextColumnSize = nextColumn ? _region2.default.from(columnHeaderNodes[index + 1]).width : 0;

        secondSize = nextColumnSize - diff;
      }

      // if (nextColumn && secondSize < nextColumn.minWidth){
      //     secondSize = nextColumn.minWidth
      //     diff = nextColumnSize - secondSize
      //     firstSize = columnSize + diff
      // }

      var resizeInfo = [{
        name: column.name,
        size: firstSize,
        diff: diff
      }];

      if (nextColumn) {
        resizeInfo.push({
          name: nextColumn.name,
          size: secondSize,
          diff: -diff
        });
      }

      header.onResizeDrop({
        resizing: false,
        resizeColumn: null,
        resizeProxyLeft: null
      }, resizeInfo, e);
    }
  });
};

var _region = require('region');

var _region2 = _interopRequireDefault(_region);

var _dragHelper = require('drag-helper');

var _dragHelper2 = _interopRequireDefault(_dragHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var emptyFn = function emptyFn() {};